
CREATE TRIGGER POST_NEW_ORDER FOR SALES ACTIVE
AFTER INSERT POSITION 0
AS
BEGIN
    POST_EVENT 'new_order';
END


CREATE TRIGGER SAVE_SALARY_CHANGE FOR EMPLOYEE ACTIVE
AFTER UPDATE POSITION 0
AS
BEGIN
    IF (old.salary <> new.salary) THEN
        INSERT INTO salary_history
            (emp_no, change_date, updater_id, old_salary, percent_change)
        VALUES (
            old.emp_no,
            'NOW',
            user,
            old.salary,
            (new.salary - old.salary) * 100 / old.salary);
END


CREATE TRIGGER SET_CUST_NO FOR CUSTOMER ACTIVE
BEFORE INSERT POSITION 0
AS
BEGIN
    /* FIXED by helebor 19.01.2004 */
    if (new.cust_no is null) then
    new.cust_no = gen_id(cust_no_gen, 1);
END


CREATE TRIGGER SET_EMP_NO FOR EMPLOYEE ACTIVE
BEFORE INSERT POSITION 0
AS
BEGIN
    /* FIXED by helebor 19.01.2004 */
    if (new.emp_no is null) then
    new.emp_no = gen_id(emp_no_gen, 1);
END


