/* ************************** */
/* DELIMITER = dtDefault      */
/* ************************** */

ALTER TABLE CUSTOMER ADD
  FOREIGN KEY (COUNTRY) REFERENCES COUNTRY (COUNTRY);
ALTER TABLE CUSTOMER ADD 
  CHECK (on_hold IS NULL OR on_hold = '*');
CREATE INDEX CUSTNAMEX ON CUSTOMER (CUSTOMER);
CREATE INDEX CUSTREGION ON CUSTOMER (COUNTRY,CITY);
ALTER TABLE DEPARTMENT ADD
  FOREIGN KEY (HEAD_DEPT) REFERENCES DEPARTMENT (DEPT_NO);
ALTER TABLE DEPARTMENT ADD
  FOREIGN KEY (MNGR_NO) REFERENCES EMPLOYEE (EMP_NO);
CREATE DESCENDING INDEX BUDGETX ON DEPARTMENT (BUDGET);
ALTER TABLE EMPLOYEE ADD FULL_NAME COMPUTED BY (last_name || ', ' || first_name);
ALTER TABLE EMPLOYEE ADD
  FOREIGN KEY (DEPT_NO) REFERENCES DEPARTMENT (DEPT_NO);
ALTER TABLE EMPLOYEE ADD
  FOREIGN KEY (JOB_CODE,JOB_GRADE,JOB_COUNTRY) REFERENCES JOB (JOB_CODE,JOB_GRADE,JOB_COUNTRY);
ALTER TABLE EMPLOYEE ADD 
  CHECK ( salary >= (SELECT min_salary FROM job WHERE
                        job.job_code = employee.job_code AND
                        job.job_grade = employee.job_grade AND
                        job.job_country = employee.job_country) AND
            salary <= (SELECT max_salary FROM job WHERE
                        job.job_code = employee.job_code AND
                        job.job_grade = employee.job_grade AND
                        job.job_country = employee.job_country));
CREATE INDEX NAMEX ON EMPLOYEE (LAST_NAME,FIRST_NAME);
ALTER TABLE EMPLOYEE_PROJECT ADD
  FOREIGN KEY (EMP_NO) REFERENCES EMPLOYEE (EMP_NO);
ALTER TABLE EMPLOYEE_PROJECT ADD
  FOREIGN KEY (PROJ_ID) REFERENCES PROJECT (PROJ_ID);
ALTER TABLE JOB ADD
  FOREIGN KEY (JOB_COUNTRY) REFERENCES COUNTRY (COUNTRY);
ALTER TABLE JOB ADD 
  CHECK (min_salary < max_salary);
CREATE DESCENDING INDEX MAXSALX ON JOB (JOB_COUNTRY,MAX_SALARY);
CREATE INDEX MINSALX ON JOB (JOB_COUNTRY,MIN_SALARY);
ALTER TABLE PROJECT ADD
  FOREIGN KEY (TEAM_LEADER) REFERENCES EMPLOYEE (EMP_NO);
CREATE UNIQUE INDEX PRODTYPEX ON PROJECT (PRODUCT,PROJ_NAME);
ALTER TABLE PROJ_DEPT_BUDGET ADD
  FOREIGN KEY (DEPT_NO) REFERENCES DEPARTMENT (DEPT_NO);
ALTER TABLE PROJ_DEPT_BUDGET ADD
  FOREIGN KEY (PROJ_ID) REFERENCES PROJECT (PROJ_ID);
ALTER TABLE PROJ_DEPT_BUDGET ADD 
  CHECK (FISCAL_YEAR >= 1993);
ALTER TABLE SALARY_HISTORY ADD NEW_SALARY COMPUTED BY (old_salary + old_salary * percent_change / 100);
ALTER TABLE SALARY_HISTORY ADD
  FOREIGN KEY (EMP_NO) REFERENCES EMPLOYEE (EMP_NO);
ALTER TABLE SALARY_HISTORY ADD 
  CHECK (percent_change between -50 and 50);
CREATE DESCENDING INDEX CHANGEX ON SALARY_HISTORY (CHANGE_DATE);
CREATE INDEX UPDATERX ON SALARY_HISTORY (UPDATER_ID);
ALTER TABLE SALES ADD AGED COMPUTED BY (ship_date - order_date);
ALTER TABLE SALES ADD
  FOREIGN KEY (CUST_NO) REFERENCES CUSTOMER (CUST_NO);
ALTER TABLE SALES ADD
  FOREIGN KEY (SALES_REP) REFERENCES EMPLOYEE (EMP_NO);
ALTER TABLE SALES ADD 
  CHECK (order_status in
                            ('new', 'open', 'shipped', 'waiting'));
ALTER TABLE SALES ADD 
  CHECK (ship_date >= order_date OR ship_date IS NULL);
ALTER TABLE SALES ADD 
  CHECK (date_needed > order_date OR date_needed IS NULL);
ALTER TABLE SALES ADD 
  CHECK (paid in ('y', 'n'));
ALTER TABLE SALES ADD 
  CHECK (qty_ordered >= 1);
ALTER TABLE SALES ADD 
  CHECK (total_value >= 0);
ALTER TABLE SALES ADD 
  CHECK (discount >= 0 AND discount <= 1);
ALTER TABLE SALES ADD 
  CHECK (NOT (order_status = 'shipped' AND ship_date IS NULL));
ALTER TABLE SALES ADD 
  CHECK (NOT (order_status = 'shipped' AND
            EXISTS (SELECT on_hold FROM customer
                    WHERE customer.cust_no = sales.cust_no
                    AND customer.on_hold = '*')));
CREATE INDEX NEEDX ON SALES (DATE_NEEDED);
CREATE DESCENDING INDEX QTYX ON SALES (ITEM_TYPE,QTY_ORDERED);
CREATE INDEX SALESTATX ON SALES (ORDER_STATUS,PAID);