unit FormZeosAnlage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, EditBtn, FileCtrl, IBConnection, datamodulezeos, LemRoutines;

type

  { TFormFBAnlegen }

  TFormFBAnlegen = class(TForm)
    BBtnDatabaseCreate: TBitBtn;
    Button1: TButton;
    CHDBCharset: TComboBox;
    DEDBSetpath: TDirectoryEdit;
    EdtDatabaseZusatz: TEdit;
    EdtDatabaseName: TEdit;
    EdtDBUsername: TEdit;
    EdtDBPassword: TEdit;
    FileListBoxDB: TFileListBox;
    LblDBCharSet: TLabel;
    LblSetStorageLocation: TLabel;
    LblDBName: TLabel;
    LblFDBType: TLabel;
    LblDBPassword: TLabel;
    LBLDBExists: TLabel;
    Memo1: TMemo;
    procedure BBtnDatabaseCreateClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DEDBSetpathChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LBLDBExistsClick(Sender: TObject);

  private

  public

  end;

var
  FormFBAnlegen: TFormFBAnlegen;

{ **************************************************************************** }
{ *                              IMPLEMTATION                                * }
{ **************************************************************************** }
implementation

{$R *.lfm}

{ ================================================================== }
{ TFormFBAnlegen Create                                              }
{ ================================================================== }
procedure TFormFBAnlegen.BBtnDatabaseCreateClick(Sender: TObject);

var                    dbname : string;
             section, key, inn: string;
             Usr, Pawo, Chrset: string;

begin
  { User, Passwort und Characterset an Variable übernehmen }
  Usr:= EdtDBUsername.Text;
  Pawo:= EdtDBPassword.Text;
  Chrset:= CHDBCharset.Text;

  { Pfad und Dateinamen zusammenstellen }
  dbname:= DEDBSetpath.Text+ '\'+ EdtDatabaseName.Text+'.FDB';

  { Wenn die Datenbank existiert dieErstellroutine abbrechen! }
  if fileexists(dbname) = true then begin
    LBLDBExists.visible := true;
    LBLDBExists.color := clYellow;
    LBLDBExists.Font.color := clBlack;
    LBLDBExists.caption := ' Datenbank existiert bereits! ';
    exit; // Datenbank existiert, Routine verlassen
  end;

  { Werte an die Zeosconnectkomponente übergeben }
  with dmZeosFirebird.ZConnectionFirebird do begin
    Database:= dbname;
    Protocol := DBProtocol; // firebird
    User := Usr;
    Password := Pawo;
    Properties.Clear;
    { Script für die Erstellung der Datenbank zusammenbauen }
    Properties.Add ('CreateNewDatabase=CREATE DATABASE ' +
      QuotedStr (dbname) +
      ' USER ' +
      QuotedStr(Usr) +
      ' PASSWORD ' + QuotedStr(Pawo) +
      ' PAGE_SIZE 4096 DEFAULT CHARACTER SET '+ Chrset);

    { Zeige den Script  an }
    Memo1.Lines:= Properties;

    { Verbinden mit der Datenbank erzeugt diese }
    Connect;
    { und wieder schließen }
    Disconnect;
  end;

  { Datenbank wurde angelegt }
  if fileexists(dbname) = true then begin
    LBLDBExists.visible := true;
    LBLDBExists.color := clWindow;
    LBLDBExists.Font.color := clGreen;
    LBLDBExists.caption := ' Datenbank erfolgreich angelegt! ';
    FileListBoxDB.Directory:= 'C:\';
    FileListBoxDB.Directory:= DEDBSetpath.Text;
  end;
  { Es ist ein Fehler aufgetreten, die Datenbank wurde nicht angelegt! }
  if fileexists(dbname) = false then begin
    LBLDBExists.visible := true;
    LBLDBExists.color := clPurple;
    LBLDBExists.Font.color := clRed;
    LBLDBExists.caption := ' Fehler beim Anlegen der Datenbank! ';
    exit; // Fehlgeschlagen, Änderungen nicht in Ini schreiben }
  end;

  { Pfad und Dateiname in INI schreiben, wenn erfolgreich angelegt }

  { Sektion der INI-Datei ist Bezeichnung der Form }
  section:= FormFBAnlegen.Name;
  // Pfad zur Datenbank
  key:= 'LOCATION';
  inn:= DEDBSetpath.Text;
  GlobIniWrite(section, key, inn);
  // Datenbank
  key:= 'DATABASE';
  inn:= EdtDatabaseName.Text;
  GlobIniWrite(section, key, inn);
  // User
  key:= 'USER';
  GlobIniWrite(section, key, usr);
  // Passwort
  key:= 'PASSWORT';
  GlobIniWrite(section, key, pawo);
   // Zeichensatu
  key:= 'ZEICHENSATZ';
  GlobIniWrite(section, key, Chrset);
end;

procedure TFormFBAnlegen.Button1Click(Sender: TObject);
begin
  Close;
end;

{ ================================================================== }
{ Wenn das Verzeichnis gewechselt wird, die Dateien richtig anzeigen }
{ ================================================================== }
procedure TFormFBAnlegen.DEDBSetpathChange(Sender: TObject);
begin
  FileListBoxDB.Directory:= DEDBSetpath.Text;
end;


{ ================================================================== }
{ Tätigkeiten, wenn die Form aufgerufen wird                         }
{ ================================================================== }
procedure TFormFBAnlegen.FormCreate(Sender: TObject);

var section, key: string;

begin
  { Zuletzt angelegte Datenbank wieder anzeigen }
  { Sektion ist Bezeichnung der Form }
  section:= FormFBAnlegen.Name;
  // Datenbankpfad
  key:= 'LOCATION';
  DEDBSetpath.Text:= GlobIniRead(section, key);
  // Datenbankbezeichnung
  key:= 'DATABASE';
  EdtDatabaseName.Text:= GlobIniRead(section, key);
  // Dateiübersicht die richtige Location angeben
  FileListBoxDB.Directory:= DEDBSetpath.Text;
  // User
  key:= 'USER';
  EdtDBUsername.Text:= GlobIniRead(section, key);
  // Passwort
  key:= 'PASSWORT';
  EdtDBPassword.Text:= GlobIniRead(section, key);
  // Zeichensatz
  key:= 'ZEICHENSATZ';
  CHDBCharset.Text:= GlobIniRead(section, key);
end;

{ ================================================================== }
{ Label für Meldungen beim Anlegen der Datenbank verstecken          }
{ ================================================================== }
procedure TFormFBAnlegen.LBLDBExistsClick(Sender: TObject);
begin
  LBLDBExists.visible := false;
end;


end.

